local showIds, playerData = false, {}

local function DrawText3D(x,y,z, text, scl, font) 
  local onScreen,_x,_y = World3dToScreen2d(x,y,z)
  local px,py,pz = table.unpack(GetGameplayCamCoords())
  local dist = GetDistanceBetweenCoords(px,py,pz,x,y,z,1)
  local scale = (1/dist*scl)*(1/GetGameplayCamFov()*100);
 
  if onScreen then
    SetTextScale(0.0*scale, 1.1*scale)
    SetTextFont(font or 0)
    SetTextProportional(1)
    SetTextColour(255, 255, 255, 255)
    SetTextDropshadow(0, 0, 0, 0, 255)
    SetTextEdge(2, 0, 0, 0, 150)
    SetTextDropShadow()
    SetTextOutline()
    SetTextEntry("STRING")
    SetTextCentre(1)
    AddTextComponentString(text)
    DrawText(_x,_y)
  end
end

RegisterCommand("+viewIds_startpenis", function()
  showIds = true
  loadAnimDict("anim@heists@ornate_bank@thermal_charge")
  TaskPlayAnim(_GPED, "anim@heists@ornate_bank@thermal_charge", "cover_eyes_loop", 8.0, -8, -1, 49, 0, 0, 0, 0)

  SetTimeout(10000,function()
    if showIds then
      ExecuteCommand("-viewIds_startpenis")
    end
  end)

  CreateThread(function()
    while showIds do
      for _, id in ipairs(GetActivePlayers()) do
        if NetworkIsPlayerActive(id) then
          local uPed = GetPlayerPed(id)

          if uPed ~= _GPED then
            local sId = GetPlayerServerId(id)
            local uData = playerData[sId]
            local uPos = GetEntityCoords(uPed)

            if uData and not uData.drawing then
              playerData[sId].drawing = true

              CreateThread(function()
                while #(uPos - _GCOORDS) <= 13 and showIds do
                  uPos = GetEntityCoords(uPed)

                  DrawText3D(uPos.x, uPos.y, uPos.z + 1.0, uData.user_id, 1.650)
                  Wait(1)
                end

                playerData[sId].drawing = false
              end)
            end
          end
        end
      end
      Wait(3000)
    end
  end)
end)

RegisterCommand("-viewIds_startpenis", function()
  showIds = false
  ClearPedTasks(_GPED)
end)

RegisterKeyMapping("+viewIds_startpenis", "Vezi ID-urile jucatorilor", "keyboard", "DELETE")

RegisterNetEvent("id:initPlayer")
AddEventHandler("id:initPlayer", function(src, uid)
	playerData[src] = {user_id = uid}
end)

RegisterNetEvent("id:removePlayer")
AddEventHandler("id:removePlayer", function(src)
	playerData[src] = nil
end)
